PANICButton = { } ;
function PANICButton:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function PANICButton:create()
	--self:test()

	self.isHidden = false

	self.panicFrame = CreateFrame("Button", "PanicButton", UIParent, "ActionButtonTemplate,SecureActionButtonTemplate")
	local x = -64*self.total + 128*(self.i-1) + math.floor(GetScreenWidth() / 2)
	--print ("X: "..x)
	--local x = math.floor((GetScreenWidth() - 128) / 2)
	local y = math.floor((GetScreenHeight() - 128) / 15)
	self.panicFrame:SetPoint("TOPLEFT", x, -y)
	self.panicFrame:SetSize(128,128)
	self.panicFrame:EnableMouse(true)
	self.panicFrame.texture = self.panicFrame:CreateTexture()
	if (self.icon) then
		self.panicFrame.texture:SetTexture(self.icon)
	else
		self.panicFrame.texture:SetTexture(self.config.icon) --Jesus saves
	end
	self.panicFrame.texture:SetAllPoints(self.panicFrame)
	--self.panicFrame:SetTexture(self.panicFrame.texture, true)
	self.panicFrame.background = self.panicFrame.texture
	self.panicFrame:SetText(self.macro)
	--self.panicFrame:SetAllPoints(self.panicFrame)
	self.panicFrame:Show()
	self:hide()
	self.panicFrame:SetAttribute("type", "macro");
	--self.panicFrame:SetAttribute("action", 1);
	--self.panicFrame:SetAttribute("target", "self");
	--print(self:dump(self.config.macros))

	--print("macro " .. self.macro)

	if (self.macro == 'Healthstone') then
		self.panicFrame:SetAttribute("macrotext","/use " .. self.macro)
		--print("/use " .. self.macro)
	else
		local name, rank, icon, castingTime, minRange, maxRange, spellID = GetSpellInfo(self.macro)
		if (name) then
			self.panicFrame:SetAttribute("macrotext","/cast [@player] " .. self.macro)
			--print("/cast [@player] " .. self.macro)
		end
	end
	--self:show()

	return self
end

function PANICButton:getSpell()
	return self.macro
end

function PANICButton:test()
	print("MACRO IS " .. self.macro)
end

function PANICButton:show()
	if (self.isHidden) then
		--print("Showing " .. self.macro)
		self.panicFrame.texture:SetAlpha(1)
		self.panicFrame:SetAlpha(1)
		self.isHidden = false
	end
end

function PANICButton:hide()
	if (not self.isHidden) then
		--print("Hiding ".. self.macro)
		self.panicFrame.texture:SetAlpha(0.25)
		self.panicFrame:SetAlpha(0.2)
		self.isHidden = true
	end
end

function PANICButton:dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. self:dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end
